/*
 * Copyright (C) 2004 Clemens Fuchslocher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */

#include <GL/gl.h>
#include <GL/glu.h>

#include "GlActionVisitor.h"


namespace nsSceneGraph {

GlActionVisitor::~GlActionVisitor(void)
{
	DEBUG_MESSAGE("GlActionVisitor::~GlActionVisitor()")
}


inline void GlActionVisitor::action(GraphNode *node)
{
	DEBUG_MESSAGE("GlActionVisitor::action(GraphNode *node)")

	if (!node->isNodeCompiled())
	{
		return;
	}

	glCallList(node->getCompiledDisplayList());
	GL_ERROR_CHECK
}


void GlActionVisitor::visit(Group *group)
{
	DEBUG_MESSAGE("GlActionVisitor::visit(Group *group)")
}


void GlActionVisitor::visit(Material *material)
{
	DEBUG_MESSAGE("GlActionVisitor::visit(Material *material)")

	this->action(material);
}


void GlActionVisitor::visit(Transform *transform)
{
	DEBUG_MESSAGE("GlActionVisitor::visit(Transform *transform)")

	this->action(transform);
}


void GlActionVisitor::visit(VertexArray *array)
{
	DEBUG_MESSAGE("GlActionVisitor::visit(VertexArray *array)")

	this->action(array);
}


}

